set(libContemporary_VERSION 6.0.0)


####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was libcontemporaryConfig.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../" ABSOLUTE)

# Use original install prefix when loaded through a "/usr move"
# cross-prefix symbolic link such as /lib -> /usr/lib.
get_filename_component(_realCurr "${CMAKE_CURRENT_LIST_DIR}" REALPATH)
get_filename_component(_realOrig "/usr/lib/cmake/libcontemporary" REALPATH)
if(_realCurr STREQUAL _realOrig)
  set(PACKAGE_PREFIX_DIR "/usr")
endif()
unset(_realOrig)
unset(_realCurr)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
include("${CMAKE_CURRENT_LIST_DIR}/libcontemporaryTargets.cmake")

file(GLOB EXTRA_FUNCTIONS "${CMAKE_CURRENT_LIST_DIR}/cmake-scripts/*.cmake")
foreach(f ${EXTRA_FUNCTIONS})
    include(${f})
endforeach()

define_property(TARGET PROPERTY CNTP_DATA_SUBDIR
    BRIEF_DOCS "Path within data directory to place standard data (usually the application name)"
    FULL_DOCS "Path within data directory to place standard data (usually the application name)")

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Widgets Svg Network Multimedia Concurrent PrintSupport OPTIONAL_COMPONENTS DBus)
find_package(QCoro${QT_VERSION_MAJOR} COMPONENTS Core Network OPTIONAL_COMPONENTS DBus)
cntp_find_pkgconfig(Unwind libunwind)
cntp_find_pkgconfig(X11 x11)
cntp_find_pkgconfig(GsettingsQt gsettings-qt)

check_required_components(libContemporary)
